#ifdef NOSTUB
#error PedroM native format is Kernel mode! Remove _nostub definition.
#endif

#ifdef DOORS
#ifndef __PEDROM__
#error Please, do not use tigcc std headers if you want to create a PedroM program.
#endif
#endif

#ifndef __PEDROM__
#define __PEDROM__

/* if no target are defined, compiled for all calcs */
#ifndef USE_TI92PLUS
#ifndef USE_TI89
#ifndef USE_V200
#define USE_TI92PLUS
#define	USE_TI89
#define USE_V200
#endif
#endif
#endif

#undef	NO_AMS_CHECK				/* Useless for PedroM */
#undef	NO_CALC_DETECT				/* Useless for Kernel mode */
#undef	EXECUTE_IN_GHOST_SPACE			/* Useless for PedroM */
#undef	USE_KERNEL				
#undef  MIN_AMS

#undef	USE_FLINE_EMULATOR			/* Useless for Pedrom? */
#undef	USE_INTERNAL_FLINE_EMULATOR		/* Useless for PedroM */
#undef	RETURN_VALUE				/* Return value are not comaptible */

#define	NO_AMS_CHECK
#define	NO_CALC_DETECT
#define	USE_KERNEL
#define MIN_AMS 101

#define DOORS					/* To avoid double entry point */

#include <default.h>				/* Include std header from tigcc */
#include <romsymb.h>

#define pedrom_rom_call_addr(index) (__jmp_tbl[0x##index])
#define pedrom_rom_call_addr_concat(intindex,romindex) (__jmp_tbl[intindex])
#define pedrom_rom_call(type,args,index) (*((type(*__ATTR_TIOS__)args)(pedrom_rom_call_addr_concat(0x##index,_ROM_CALL_##index))))
#define IS_ROMCALL_DEFINED(index) (pedrom_rom_call_addr(index) != pedrom_rom_call(169))

extern	unsigned long pedrom__0000[];
extern  void pedrom__0001(void *adr asm("a0"));

/* int main(int argc, char *argv[]);
 * Should be define as a startup section of tigcc v0.95 
 * This is not as small as it could be, but at least it should work with both v0.94 and v0.95
 */
#undef main
#define main __dummy__function__();\
	void __main(void) {} \
	void _main(void) { asm("lea main,%a0 \n jbsr pedrom__0001 \n");}\
	__ATTR_TIOS__ int	main

#endif						/* __PEDROM__*/
